# Python Generic DB REST Server

A simple Python flask server that will host a single-table `sqlite` database called `data.db` to hold any data given by a REST POST request. When a successful submission is accepted, the server will automatically generate the following parameters for that record:

* `id` : a unique primary key that auto increments
* `owner` : the user responsible for the submission in the format: `HTTP_HOST::HTTP_USER_AGENT`
* `date_created` : a datetime stamp when the data was commited to the table

## Installation

Download this repo and install dependencies:

```
git clone https://gitlab.com/noroff-accelerate/embedded-bootcamp/projects/python-generic-db-rest-server
cd python-generic-db-rest-server
pip3 install -r requirements.txt
```

## Usage

To run this server simply run the following command:
```
python3 src/main.py
```
This will deploy a Flask server that will listen on 
```
http://127.0.0.1:5000
```
by default.

## REST API specification

The server has the following endpoints:

| URL     | Method  | Required Header | Success | Error | Purpose |
|:-------:|:-------:|-----------------|:-------:|:-----:|:--------|
|`/`      |`GET`      | |`200`    | | A simple `GET` end point to test if the server is running succesfully. Will return number of rows in Data table within response message. |
|`/submit` |`POST`      | `application/json` |`201`    | `400` | The primary `POST` endpoint to the server that allows any data to be submitted to the Data table. The data must be in the form of a JSON object with the following parameters: `{ "data": <any JSON type>, "meta": <string> }`. On success: a new data entry is committed to the db with additional autogenerated paramters: `id`, `owner`, and `date_created` |
|`/fetch`  |`GET`       | | `200` | `400` | An endpoint to fetch all rows of data of that client. On success: will respond with a JSON list containing all rows where the `owner` matches the sender's `HTTP_HOST::HTTP_USER_AGENT` header. If request agent is not found then an empty list will be returned. |
|`/fetch`  |`POST`       | `application/json`| `200` | `400` `404` | Same as above but the user's name is not extracted from header, instead the user or owner name is specified in a JSON object with the following parameters: `{ "user": <string> }` |
|`/fetch/all`  |`GET`       | | `200` || Fetches all entries in database as a JSON list object |
|`/fetch/<id>` | `GET`  | | `200` | `404` | Fetches the row using the unqiue id provided in `<id>`. Will result in `404` if `id` does not exist. |
|`/upload`  | `POST`    | `multipart/form-data` | `201` | `400` | Similar to `/submit` but allows the uploading of images as base64 encoded images into the `data` attribute. The file is sent to the server using a form where `image` must be the file location of the desired image. On success: the image is encoded to base 64 and stored in `data`, the image mimetype is stored in `meta_data`; all other attributes are autogenerated as normal. Acceptable image formats: `'png', 'jpg', 'jpeg', 'gif'` |

## Examples
Below is are examples of using the end points successfully

1. Fetching database status
```
$ curl http://127.0.0.1:5000/
> Generic database, serving 0 entries.
```

2. Submitting a new row to the database
```
$ curl -X POST -H "Content-Type: application/json" -d "{\"data\" : \"hello world\", \"meta\": \"text\" }" http://127.0.0.1:5000/submit
> Data entry created
```

3. Fetching all the requester's specific data entries
```
$ curl http://127.0.0.1:5000/fetch
> [
    {"id": 1, 
    "owner": "127.0.0.1:5000::curl/7.68.0", 
    "date_created": "2022-02-01 12:11:07.105922", 
    "data": "hello world", 
    "meta_data": "text"
  }]
```

4. Fetching all data
```
$ curl http://127.0.0.1:5000/fetch/all
> [
    {"id": 1, 
    "owner": "127.0.0.1:5000::curl/7.68.0", 
    "date_created": "2022-02-01 12:11:07.105922", 
    "data": "hello world", 
    "meta_data": "text"
  }]
```

5. Uploading a new image as base64 encoded text into the database
```
$ curl -X POST -F "image=@Clipboard01.png" http://127.0.0.1:5000/upload
> Image uploaded successfully.
```


## Maintainers 

JC Bailey - @thelunararmy

## License 

MIT © 2022 Noroff Accelerate




